<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__lvd" kind="group">
    <compoundname>group_lvd</compoundname>
    <title>LVD          (Low-Voltage-Detect)</title>
    <innergroup refid="group__group__lvd__macros">Macros</innergroup>
    <innergroup refid="group__group__lvd__functions">Functions</innergroup>
    <innergroup refid="group__group__lvd__enums">Enumerated Types</innergroup>
    <briefdescription>
<para>The LVD driver provides an API to manage the Low Voltage Detection block. </para>    </briefdescription>
    <detaileddescription>
<para>The functions and other declarations used in this driver are in cy_lvd.h. You can include cy_pdl.h to get access to all functions and declarations in the PDL.</para><para>The LVD block provides a status of currently observed VDDD voltage and triggers an interrupt when the observed voltage crosses an adjusted threshold.</para>
<para><heading level="1">Configuration Considerations</heading></para>
<para>To set up an LVD, configure the voltage threshold by the <ref kindref="member" refid="group__group__lvd__functions_1ga59ac02fec5dbbba9c16b7b72beaa91b8">Cy_LVD_SetThreshold</ref> function, ensure that the LVD block itself and LVD interrupt are disabled (by the <ref kindref="member" refid="group__group__lvd__functions_1ga3eba25c246f5977fca59309c198743a0">Cy_LVD_Disable</ref> and <ref kindref="member" refid="group__group__lvd__functions_1ga1de4327b866c4002806eb915023f438e">Cy_LVD_ClearInterruptMask</ref> functions correspondingly) before changing the threshold to prevent propagating a false interrupt. Then configure interrupts by the <ref kindref="member" refid="group__group__lvd__functions_1gaf9f813c4673a427b7a8aa35447f91cf0">Cy_LVD_SetInterruptConfig</ref> function, do not forget to initialize an interrupt handler (the interrupt source number is srss_interrupt_IRQn). Then enable LVD by the <ref kindref="member" refid="group__group__lvd__functions_1ga855b38a29ad7ce794e38f09e546f14c4">Cy_LVD_Enable</ref> function, then wait for at least 20us to get the circuit stabilized and clear the possible false interrupts by the <ref kindref="member" refid="group__group__lvd__functions_1gaadd0bff934f82db8d5630ab9163fbf49">Cy_LVD_ClearInterrupt</ref>, and finally the LVD interrupt can be enabled by the <ref kindref="member" refid="group__group__lvd__functions_1ga7f58d4e85f404434cf4f0b89c35143d2">Cy_LVD_SetInterruptMask</ref> function.</para><para>For example: <programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__lvd__functions_1ga1de4327b866c4002806eb915023f438e">Cy_LVD_ClearInterruptMask</ref>();</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__lvd__functions_1ga59ac02fec5dbbba9c16b7b72beaa91b8">Cy_LVD_SetThreshold</ref>(<ref kindref="member" refid="group__group__lvd__enums_1gga4eaeaadf154cb3cbc9af0b4abcd56f62a5a8a453fdb6ced002661791f4e37c6e4">CY_LVD_THRESHOLD_2_5_V</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__lvd__functions_1gaf9f813c4673a427b7a8aa35447f91cf0">Cy_LVD_SetInterruptConfig</ref>(<ref kindref="member" refid="group__group__lvd__enums_1gga86656c2b083eef9b483a09ef4078257eadebb3940980d08388fb545812799a3c8">CY_LVD_INTR_BOTH</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__lvd__functions_1ga855b38a29ad7ce794e38f09e546f14c4">Cy_LVD_Enable</ref>();</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__syslib__functions_1ga9d2ffe4829c636ad78eaae5043fd6ae6">Cy_SysLib_DelayUs</ref>(20U);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__lvd__functions_1gaadd0bff934f82db8d5630ab9163fbf49">Cy_LVD_ClearInterrupt</ref>();</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__lvd__functions_1ga7f58d4e85f404434cf4f0b89c35143d2">Cy_LVD_SetInterruptMask</ref>();</highlight></codeline>
</programlisting> Note that the LVD circuit is available only in Low Power and Ultra Low Power modes. If an LVD is required in Deep Sleep mode, then the device should be configured to periodically wake up from Deep Sleep using a Deep Sleep wakeup source. This makes sure a LVD check is performed during Low Power or Ultra Low Power modes.</para>

<para><heading level="1">More Information</heading></para>
<para>See the LVD chapter of the device technical reference manual (TRM).</para>

<para><heading level="1">MISRA-C Compliance</heading></para>
<para>The LVD driver has the following specific deviations: <verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;MISRA Rule &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Class (Required/Advisory) &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Description &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Description of Deviation(s)  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;10.3 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;R &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A composite expression of 'essentially unsigned' type (%1s) is being cast to a different type category, '%2s'. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The value got from the bitfield physically can't exceed the enumeration that describes this bitfield. So the code is safety by design.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;16.7 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The object addressed by the pointer parameter 's' is not modified and so the pointer could be of type 'pointer to const'. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The pointer parameter is not used or modified, as there is no need to do any actions with it. However, such parameter is required to be presented in the function, because the &lt;a href="group__group__lvd__functions__syspm__callback.html#group__group__lvd__functions__syspm__callback_1ga174e16f9519ae832fd711a609f86bc06"&gt;Cy_LVD_DeepSleepCallback&lt;/a&gt; is a callback of &lt;a href="group__group__syspm__data__enumerates.html#group__group__syspm__data__enumerates_1ga601b1cb722cb091133caf33d8ab235ca"&gt;cy_en_syspm_status_t&lt;/a&gt; type. The SysPM driver callback function type requires implementing the function with the next parameters and return value: &lt;br /&gt; cy_en_syspm_status_t (*Cy_SysPmCallback) (&lt;a href="structcy__stc__syspm__callback__params__t.html#"&gt;cy_stc_syspm_callback_params_t&lt;/a&gt; *callbackParams);  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>

<para><heading level="1">Changelog</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Version&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Changes&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Reason of Change &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.20 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated the following functions for the PSoC 64 devices: &lt;a href="group__group__lvd__functions.html#group__group__lvd__functions_1ga855b38a29ad7ce794e38f09e546f14c4"&gt;Cy_LVD_Enable&lt;/a&gt;, &lt;a href="group__group__lvd__functions.html#group__group__lvd__functions_1ga3eba25c246f5977fca59309c198743a0"&gt;Cy_LVD_Disable&lt;/a&gt;, &lt;a href="group__group__lvd__functions.html#group__group__lvd__functions_1ga59ac02fec5dbbba9c16b7b72beaa91b8"&gt;Cy_LVD_SetThreshold&lt;/a&gt;, &lt;a href="group__group__lvd__functions.html#group__group__lvd__functions_1gaadd0bff934f82db8d5630ab9163fbf49"&gt;Cy_LVD_ClearInterrupt&lt;/a&gt;, &lt;a href="group__group__lvd__functions.html#group__group__lvd__functions_1ga7f875a2e19d66badf8736ffc75b96665"&gt;Cy_LVD_SetInterrupt&lt;/a&gt;, &lt;a href="group__group__lvd__functions.html#group__group__lvd__functions_1ga7f58d4e85f404434cf4f0b89c35143d2"&gt;Cy_LVD_SetInterruptMask&lt;/a&gt;, &lt;a href="group__group__lvd__functions.html#group__group__lvd__functions_1ga1de4327b866c4002806eb915023f438e"&gt;Cy_LVD_ClearInterruptMask&lt;/a&gt;, and &lt;a href="group__group__lvd__functions.html#group__group__lvd__functions_1gaf9f813c4673a427b7a8aa35447f91cf0"&gt;Cy_LVD_SetInterruptConfig&lt;/a&gt;.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added PSoC 64 device support.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.10 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Flattened the organization of the driver source code into the single source directory and the single include directory.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Driver library directory-structure simplification.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added register access layer. Use register access macros instead of direct register access using dereferenced pointers. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Makes register access device-independent, so that the PDL does not need to be recompiled for each supported part number.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.0.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added Low Power Callback section &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation update and clarification  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Initial Version &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>
    </detaileddescription>
  </compounddef>
</doxygen>